only create a fulldir if need one
[xfstests-dev.git] / check
1 #!/bin/sh
2 #
3 # Control script for QA
4 #
5 # Copyright (c) 2000-2002 Silicon Graphics, Inc.  All Rights Reserved.
6
7 # This program is free software; you can redistribute it and/or modify it
8 # under the terms of version 2 of the GNU General Public License as
9 # published by the Free Software Foundation.
10
11 # This program is distributed in the hope that it would be useful, but
12 # WITHOUT ANY WARRANTY; without even the implied warranty of
13 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
14
15 # Further, this software is distributed without any warranty that it is
16 # free of the rightful claim of any third person regarding infringement
17 # or the like.  Any license provided herein, whether implied or
18 # otherwise, applies only to this software file.  Patent licenses, if
19 # any, provided herein do not apply to combinations of this program with
20 # other software, or any other product whatsoever.
21
22 # You should have received a copy of the GNU General Public License along
23 # with this program; if not, write the Free Software Foundation, Inc., 59
24 # Temple Place - Suite 330, Boston MA 02111-1307, USA.
25
26 # Contact information: Silicon Graphics, Inc., 1600 Amphitheatre Pkwy,
27 # Mountain View, CA  94043, or:
28
29 # http://www.sgi.com 
30
31 # For further information regarding this notice, see: 
32
33 # http://oss.sgi.com/projects/GenInfo/SGIGPLNoticeExplan/
34 #
35
36 export MKFS_OPTIONS=${MKFS_OPTIONS:=-bsize=4096}
37 export MOUNT_OPTIONS=${MOUNT_OPTIONS:=-ologbufs=2}
38
39 tmp=/tmp/$$
40 status=0
41 needwrap=true
42 try=0
43 n_bad=0
44 bad=""
45 notrun=""
46 interrupt=true
47
48 # generic initialization
49 iam=check
50 if ! . ./common.rc
51 then
52     echo "check: failed to source common.rc"
53     exit 1
54 fi
55
56 if [ $UID -ne 0 ]
57 then
58     echo "check: QA must be run as root"
59     exit 1
60 fi
61
62 _wallclock()
63 {
64     date "+%H %M %S" | $AWK_PROG '{ print $1*3600 + $2*60 + $3 }'
65 }
66
67 _wrapup()
68 {
69     # for hangcheck ...
70     # remove files that were used by hangcheck
71     #
72     [ -f /tmp/check.pid ] && rm -rf /tmp/check.pid
73     [ -f /tmp/check.sts ] && rm -rf /tmp/check.sts
74
75     if $showme
76     then
77         :
78     elif $needwrap
79     then
80         if [ -f check.time -a -f $tmp.time ]
81         then
82             cat check.time $tmp.time \
83             | $AWK_PROG '
84         { t[$1] = $2 }
85 END     { if (NR > 0) {
86             for (i in t) print i " " t[i]
87           }
88         }' \
89             | sort -n >$tmp.out
90             mv $tmp.out check.time
91         fi
92
93         if [ -f $tmp.expunged ]
94         then
95             notrun=`wc -l <$tmp.expunged | sed -e 's/  *//g'`
96             try=`expr $try - $notrun`
97             list=`echo "$list" | sed -f $tmp.expunged`
98         fi
99
100         echo "" >>check.log
101         date >>check.log
102         echo $list | fmt | sed -e 's/^/    /' >>check.log
103         $interrupt && echo "Interrupted!" >>check.log
104         
105         if [ ! -z "$notrun" ]
106         then
107             echo "Not run:$notrun"
108             echo "Not run:$notrun" >>check.log
109         fi
110         if [ ! -z "$n_bad" -a $n_bad != 0 ]
111         then
112             echo "Failures:$bad"
113             echo "Failed $n_bad of $try tests"
114             echo "Failures:$bad" | fmt >>check.log
115             echo "Failed $n_bad of $try tests" >>check.log
116         else
117             echo "Passed all $try tests"
118             echo "Passed all $try tests" >>check.log
119         fi
120         needwrap=false
121     fi
122
123     rm -f /tmp/*.rawout /tmp/*.out /tmp/*.err /tmp/*.time
124     rm -f /tmp/check.pid /tmp/check.sts
125     rm -f $tmp.*
126 }
127
128 trap "_wrapup; exit \$status" 0 1 2 3 15
129
130 # for hangcheck ...
131 # Save pid of check in a well known place, so that hangcheck can be sure it
132 # has the right pid (getting the pid from ps output is not reliable enough).
133 #
134 rm -rf /tmp/check.pid
135 echo $$ >/tmp/check.pid
136
137 # for hangcheck ...
138 # Save the status of check in a well known place, so that hangcheck can be
139 # sure to know where check is up to (getting test number from ps output is
140 # not reliable enough since the trace stuff has been introduced).
141 #
142 rm -rf /tmp/check.sts
143 echo "preamble" >/tmp/check.sts
144
145 # don't leave old full output behind on a clean run
146 rm -f check.full
147
148 # by default don't output timestamps
149 timestamp=${TIMESTAMP:=false}
150
151 . ./common
152
153 [ -f check.time ] || touch check.time
154
155 FULL_FSTYP_DETAILS=`_full_fstyp_details`
156 FULL_HOST_DETAILS=`_full_platform_details`
157 FULL_MKFS_OPTIONS=`_scratch_mkfs_options`
158 FULL_MOUNT_OPTIONS=`_scratch_mount_options`
159
160 cat <<EOF
161 FSTYP         -- $FULL_FSTYP_DETAILS
162 PLATFORM      -- $FULL_HOST_DETAILS
163 MKFS_OPTIONS  -- $FULL_MKFS_OPTIONS
164 MOUNT_OPTIONS -- $FULL_MOUNT_OPTIONS
165
166 EOF
167
168 umount $SCRATCH_DEV 2>/dev/null
169 # call the overridden mkfs.xfs - make sure the FS is built
170 # the same as we'll create it later.
171 if ! _scratch_mkfs_xfs -f >$tmp.err 2>&1
172 then
173     echo "our local _scratch_mkfs_xfs routine ..."
174     cat $tmp.err
175     echo "check: failed to mkfs.xfs \$SCRATCH_DEV using specified options"
176     exit 1
177 fi
178
179 # call the overridden mount - make sure the FS mounts with
180 # the same options that we'll mount with later.
181 if ! _scratch_mount >$tmp.err 2>&1
182 then
183     echo "our local mount routine ..."
184     cat $tmp.err
185     echo "check: failed to mount \$SCRATCH_DEV using specified options"
186     exit 1
187 fi
188
189 seq="check"
190 _check_test_fs
191
192 for seq in $list
193 do
194     err=false
195     echo -n "$seq"
196     if $showme
197     then
198         echo
199         continue
200     elif [ -f expunged ] && $expunge && egrep "^$seq([  ]|\$)" expunged >/dev/null
201     then
202         echo " - expunged"
203         rm -f $seq.out.bad
204         echo "/^$seq\$/d" >>$tmp.expunged
205     elif [ ! -f $seq ]
206     then
207         echo " - no such test?"
208         echo "/^$seq\$/d" >>$tmp.expunged
209     else
210         # really going to try and run this one
211         #
212         rm -f $seq.out.bad
213         lasttime=`sed -n -e "/^$seq /s/.* //p" <check.time`
214         if [ "X$lasttime" != X ]; then
215                 echo -n " ${lasttime}s ..."
216         else
217                 echo -n "       "       # prettier output with timestamps.
218         fi
219         rm -f core $seq.notrun
220
221         # for hangcheck ...
222         echo "$seq" >/tmp/check.sts
223
224         start=`_wallclock`
225         $timestamp && echo -n " ["`date "+%T"`"]"
226         sh $seq >$tmp.rawout 2>&1
227         sts=$?
228         $timestamp && echo -n " ["`date "+%T"`"]"
229         stop=`_wallclock`
230
231         _fix_malloc <$tmp.rawout >$tmp.out
232         rm -f $tmp.rawout
233
234         if [ -f core ]
235         then
236             echo -n " [dumped core]"
237             mv core $seq.core
238             err=true
239         fi
240
241         if [ -f $seq.notrun ]
242         then
243             $timestamp || echo -n " [not run] "
244             $timestamp && echo " [not run]" && echo -n "        $seq -- "
245             cat $seq.notrun
246             notrun="$notrun $seq"
247         else
248             if [ $sts -ne 0 ]
249             then
250                 echo -n " [failed, exit status $sts]"
251                 err=true
252             fi
253             if [ ! -f $seq.out ]
254             then
255                 echo " - no qualified output"
256                 err=true
257             else
258                 if diff $seq.out $tmp.out >/dev/null 2>&1
259                 then
260                     echo ""
261                     if $err
262                     then
263                         :
264                     else
265                         echo "$seq `expr $stop - $start`" >>$tmp.time
266                     fi
267                 else
268                     echo " - output mismatch (see $seq.out.bad)"
269                     mv $tmp.out $seq.out.bad
270                     $diff $seq.out $seq.out.bad
271                     err=true
272                 fi
273             fi
274         fi
275
276     fi
277
278     # come here for each test, except when $showme is true
279     #
280     if $err
281     then
282         bad="$bad $seq"
283         n_bad=`expr $n_bad + 1`
284         quick=false
285     fi
286     [ -f $seq.notrun ] || try=`expr $try + 1`
287     
288     seq="after_$seq"
289     _check_test_fs
290     
291 done
292
293 interrupt=false
294 status=`expr $n_bad`
295 exit